#include <exec/types.h>
#include <intuition/intuition.h>

struct IntuitionBase *IntuitionBase;
struct GfxBase *GfxBase;

#define INTUITION_REV 33
#define GRAPHICS_REV 33

/* Open_All() sets up the intuition environment for the user */

void Open_All(void)
{
	IntuitionBase = (struct IntuitionBase *)
					OpenLibrary("intuition.library",INTUITION_REV);
	if(IntuitionBase == NULL) 
		exit(FALSE);
	GfxBase = (struct GfxBase *)
					OpenLibrary("graphics.library",GRAPHICS_REV);
	if(GfxBase == NULL)
		exit(FALSE);
}

/* Close_All() closes all the libraries that Open_All() opens */

void Close_All(void)
{
	CloseLibrary(IntuitionBase);
	CloseLibrary(GfxBase);
}